
#ifndef _RF_SERVER_H
#define _RF_SERVER_H

#include "InternalsPlugin.hpp"
#include "Socket.hpp"

// This is used for the app to use the plugin for its intended purpose
class RFServerPlugin : public InternalsPluginV07 // REMINDER: exported function GetPluginVersion() should return 1 if you are deriving from this InternalsPluginV01, 2 for InternalsPluginV02, etc.
{

public:
    // Constructor/destructor
    RFServerPlugin();
    ~RFServerPlugin();

    // These are the functions derived from base class InternalsPlugin
    // that can be implemented.
    void Startup(long version); // game startup
    void Shutdown();            // game shutdown

    void EnterRealtime(); // entering realtime
    void ExitRealtime();  // exiting realtime

    void StartSession(); // session has started
    void EndSession();   // session has ended

    // GAME OUTPUT
    long WantsTelemetryUpdates() { return (1); } // CHANGE TO 1 TO ENABLE TELEMETRY EXAMPLE!
    void UpdateTelemetry(const TelemInfoV01 &info);

    // SCORING OUTPUT
    bool WantsScoringUpdates() { return (false); } // CHANGE TO TRUE TO ENABLE SCORING EXAMPLE!
    void UpdateScoring(const ScoringInfoV01 &info);

    bool WantsPitMenuAccess() { return (true); }
    bool AccessPitMenu(PitMenuV01 &info);

private:
    Socket *socket;
};

#endif // _RF_SERVER_H
